<?php

namespace Teknisa\DF\Modules\Saida\Controllers;

use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Row;
use Zeedhi\Framework\DataSource\DataSet;


class Dfe43200ParametrosDocumentosFiscaisSaidaController extends \Teknisa\DF\Controllers\TeknisaCrud {
    protected $dataSourceName = "";
    protected $parameterBagColumns = array("");
    protected $dataSourceNameToSave ='';

    protected $crudService;
    protected $environment;
    protected $entityManager;

    protected $Dfe43200ParametrosDocumentosFiscaisSaidaService;

    public function __construct($crudService, $parameterBag, $environment,$entityManager,$Dfe43200ParametrosDocumentosFiscaisSaidaService) {
        parent::__construct($crudService, $parameterBag);
        $this->crudService = $crudService;
        $this->environment = $environment;
        $this->entityManager = $entityManager;
        $this->Dfe43200ParametrosDocumentosFiscaisSaidaService = $Dfe43200ParametrosDocumentosFiscaisSaidaService;
    }


    public function findParametrosFilial(DTO\Request\Filter $request, DTO\Response $response) {
        try {
            $this->dataSourceName='paramfilial_saida';
            $this->parameterBagColumns = array("P_FILIAL");
            $filterCriteria = $request->getFilterCriteria();
            $filterCriteria->setDataSourceName($this->dataSourceName);
            $filterCriteria = $this->crudService->getFilterCriteriaWithNrOrg($filterCriteria);
            $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
            $this->crudService->find($response, $newFilterCriteria);
        } catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
        }
    }

    public function saveParametrosFilial(DTO\Request $request, DTO\Response $response) {
        try {
            $this->dataSourceName='paramfilial';
            $this->dataSourceNameToSave='paramfilial';
            $dataSourceName = $this->dataSourceNameToSave ? $this->dataSourceNameToSave : $this->dataSourceName;
            $rows = $this->crudService->getRowsToSave($request, $dataSourceName);
            $this->crudService->save($dataSourceName, $rows);
        } catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
        }
    }

    public function findParametrosEmpresa(DTO\Request\Filter $request, DTO\Response $response) {
        try {
            $this->dataSourceName='paramempresa_saida';
            $this->parameterBagColumns = array("P_CDEMPRESA");
            $filterCriteria = $request->getFilterCriteria();
            $filterCriteria->setDataSourceName($this->dataSourceName);
            $filterCriteria = $this->crudService->getFilterCriteriaWithNrOrg($filterCriteria);
            $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
            $this->crudService->find($response, $newFilterCriteria);
        } catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
        }
    }

    public function saveParametrosEmpresa(DTO\Request $request, DTO\Response $response) {
        try {
            $this->dataSourceName='paramempresa_saida';
            $this->dataSourceNameToSave='paramempresa';
            $dataSourceName = $this->dataSourceNameToSave ? $this->dataSourceNameToSave : $this->dataSourceName;
            $rows = $this->crudService->getRowsToSave($request, $dataSourceName);
            $this->crudService->save($dataSourceName, $rows);
        } catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
        }
    }

    public function findOperadorLogistico(DTO\Request\Filter $request, DTO\Response $response) {
        try {
            $this->dataSourceName='paramgeral_tipooperac';
            $this->parameterBagColumns = array("");
            $filterCriteria = $request->getFilterCriteria();
            $filterCriteria->setDataSourceName($this->dataSourceName);
            $filterCriteria = $this->crudService->getFilterCriteriaWithNrOrg($filterCriteria);
            $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
            $this->crudService->find($response, $newFilterCriteria);
        } catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
        }
    }

    public function saveOperadorLogistico(DTO\Request $request, DTO\Response $response) {
        try {
            $this->dataSourceName='paramgeral_tipooperac';
            $this->dataSourceNameToSave='paramgeral_tipooperac';
            $dataSourceName = $this->dataSourceNameToSave ? $this->dataSourceNameToSave : $this->dataSourceName;
            $rows = $this->crudService->getRowsToSave($request, $dataSourceName);
            $this->crudService->save($dataSourceName, $rows);
        } catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
        }
    }

    public function findGrupoOperadores(DTO\Request\Filter $request, DTO\Response $response) {
        try {
            $this->dataSourceName='paramgeral_grupoper';
            $this->parameterBagColumns = array("");
            $filterCriteria = $request->getFilterCriteria();
            $filterCriteria->setDataSourceName($this->dataSourceName);
            $filterCriteria = $this->crudService->getFilterCriteriaWithNrOrg($filterCriteria);
            $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
            $this->crudService->find($response, $newFilterCriteria);
        } catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
        }
    }

    public function saveGrupoOperadores(DTO\Request $request, DTO\Response $response) {
        try {
            $this->dataSourceName='paramgeral_grupoper';
            $this->dataSourceNameToSave='paramgeral';
            $dataSourceName = $this->dataSourceNameToSave ? $this->dataSourceNameToSave : $this->dataSourceName;
            $rows = $this->crudService->getRowsToSave($request, $dataSourceName);
            $this->crudService->save($dataSourceName, $rows);
        } catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
        }
    }

    public function realizaConsultaBanco($conditions) {
        $filterCriteria = new FilterCriteria($this->dataSourceName,$conditions);
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->Dfe43200ParametrosDocumentosFiscaisSaidaService->buscar($newFilterCriteria);
        return $dataSet;
    }


}